/*----------------------------------------------------------------------------------------- *
 * \file	fir_basic.c                                                                     *
 * \brief	loopback with FIR filtering through the HEADPHONE/LINEOUT jacks                 *
 * ---------------------------------------------------------------------------------------- */

//  ======== Includes ========================================================
#include "fir_basic.h"
#include "filter_coefficients.h"

//  ======== Globals =========================================================
Int16 x[N];          // Filter input delay line

extern void intcVectorTable( void );

//  ======== firInit =========================================================
//  initialize to 0 from x(0) to x(n-N) We are fixed to 0 all coefficients of delay line
void firInit( void )
{
	Int16 i;

	for (i = 0 ; i<N ; i++)
	{
		x[i] = 0;
	}
}

//  ======== firFloat ========================================================
float firFloat( float sampleIn )
{
		short i;
		float sampleOut = 0.0;                        // Filter output in lineout

		x[0] = sampleIn;

		    for (  i=0 ; i<N ; i++ )                // Calculate output
				sampleOut += h[i]*x[i];				 // ha is declared and initialized in header file

		    for ( i=(N-1) ; i>0 ; i-- )            // Shift delay line
			    x[i] = x[i-1]; 
		return ( sampleOut );
}

//  ======== xint0_isr ========================================================
//  Interrupt subroutine to calculate the next sample
interrupt void xint0_isr( void )
{
	float yn = 0.0;    // Filter output in lineout
	float xn;


	xn = ReadDataFromLineinLeft( );		// Input from ADC

	// yn = firFloat( xn );						// Calculate the next sample
	//yn = xn ;
		// Output to DAC
	WriteDataToLineoutStereo((Int16)(yn),(Int16)(yn));   // signal filtr 
	// WriteDataToLineoutLeft((Int16)(xn));	// signal d'entre  gauche (Noir)


	return;
}
