/*------------------------------------------------------------------------ *
 * \file	main.c                                                         *
 * \brief	implementation of main()                                       *
 * ----------------------------------------------------------------------- */

//  ======== Includes =======================================================
#include "fir_basic.h"
//#include "main.h"


//  ======== main ============================================================
//  initialization routines called by example program for interrupt-based i/o
int main( void )
	{
	/* initialization of I2C module - Set and Enable I2C clock at 20KHz */
				printf( "\n" );
				printf( "[audio TSK]: initializing I2C module...\n\n" );
				EVMOMAPL137_I2C_init( );

		/* configuration of codec AIC3106 registers - Default clock is 48KHz */
				printf( "[audio TSK]: initializing audio device...\n\n" );
				EVMOMAPL137_AIC3106_init( ADC_GAIN_0DB, DAC_ATTEN_0DB, FS_48000_HZ );
				printf( "[audio TSK]: setup AIC3106 complete...\n\n" );

		/* initialization of McASP - Only McASP1 is use in Spectrum Digital board */
				EVMOMAPL137_MCASP_init(FS_48000_HZ);
				printf( "[audio TSK]: setup McASP complete...\n\n" );
				printf( "[audio TSK]: audio device ready to work...\n\n" );

		/* initialization of average coefficients and input buffer */
				firInit( );

		/* start BSL */
				printf( " <-> Release Audio Lowpass FIR Filter --> on HP/Lineout [P12/P13]\n" );
				EVMOMAPL137_MCASP_start( );
				EVMOMAPL137_MCASP_isr( );

		/* loop forever */
				while ( 1 );
}
